com.smartgwt.client.widgets

## Class DateChooser

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.DateChooser

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClearHandlers, HasClickHandlers, HasDataChangedHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasRuleContextChangedHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasMembersChangedHandlers

      public class DateChooser
      extends VLayout
      implements HasDataChangedHandlers

  Simple interactive calendar interface used to pick a date. Used by the `DateItem` class.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `DateChooser.YearTitleFormatter` A customizer that allows you to alter the year representations used in various places in the DateChooser widget.

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DateChooser()`
    `DateChooser(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.event.shared.HandlerRegistration` | `addDataChangedHandler(DataChangedHandler handler)` Add a dataChanged handler.
    `void` | `cancelClick()` Fired when the user clicks the cancel button in this date chooser.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.String` | `getAlternateStyleSuffix()` The text appended to the style name when using `alternateWeekStyles`.
    `java.lang.Boolean` | `getAlternateWeekStyles()` Whether alternating weeks should be drawn in alternating styles.
    `IButton` | `getApplyButton()` When a DateChooser is configured for `a "datetime" value`, clicking on a date cell in the `grid` will not automatically dismiss the DateChooser canvas.
    `java.lang.String` | `getApplyButtonTitle()` Title for the `Apply` button.
    `java.lang.String` | `getBaseBottomButtonStyle()` CSS style to apply to the buttons at the bottom of the DateChooser ("Today" and "Cancel").
    `java.lang.String` | `getBaseButtonStyle()` Base CSS style applied to this picker's buttons.
    `java.lang.String` | `getBaseFiscalYearStyle()` Base CSS style applied to cells in the `fiscal year column`.
    `java.lang.String` | `getBaseNavButtonStyle()` CSS style to apply to navigation buttons and date display at the top of the component.
    `java.lang.String` | `getBaseWeekdayStyle()` Base CSS style applied to weekdays.
    `java.lang.String` | `getBaseWeekendStyle()` Base CSS style applied to weekends.
    `java.lang.String` | `getBaseWeekStyle()` Base CSS style applied to cells in the `fiscal week column`.
    `HLayout` | `getButtonLayout()` An `com.smartgwt.client.types.AutoChild` `HLayout`, rendered below the `date grid`, and showing the `Today`, `Cancel` and, when working with "datetime" values, `Apply` buttons.
    `java.lang.String[]` | `getButtonLayoutControls()` Array of members to show in the `buttonLayout`.
    `IButton` | `getCancelButton()` A button shown below the `calendar grid` which, when clicked, closes the DateChooser without selecting a value.
    `java.lang.String` | `getCancelButtonTitle()` Title for the cancellation button.
    `java.lang.Boolean` | `getCloseOnDateClick()` When editing a "date" value, with no time portion, clicking on a date-cell selects the date and closes the DateChooser.
    `boolean` | `getCloseOnEscapeKeypress()` Should this dateChooser be dismissed if the user presses the Escape key?
    `java.util.Date` | `getData()` Get the current value of the picker.
    `DateGrid` | `getDateGrid()` A `ListGrid` subclass, responsible for rendering the calendar view.
    `int` | `getDayNameLength()` How long (how many characters) should be day names be.
    `java.util.Date[]` | `getDisabledDates()` An array of Date instances that should be disabled if they appear in the calendar view.
    `java.lang.String` | `getDisabledWeekdayStyle()` Base CSS style applied to weekday dates which have been `disabled`.
    `java.lang.String` | `getDisabledWeekendStyle()` Base CSS style applied to weekend dates which have been `disabled`.
    `java.lang.Boolean` | `getDisableWeekends()` Whether it should be valid to pick a weekend day.
    `int` | `getEndYear()` Latest year that may be selected.
    `java.lang.Integer` | `getEndYearRange()` When `endYear` is unset, this is the years after today that will be available for selection in the year menu.
    `int` | `getFirstDayOfWeek()` Day of the week to show in the first column.
    `FiscalCalendar` | `getFiscalCalendar()` Returns the `FiscalCalendar` object that will be used by this DateChooser.
    `IButton` | `getFiscalYearChooserButton()` A button shown in the `navigation layout` which, when clicked, shows a picker for selecting a specific fiscal year.
    `java.lang.String` | `getFiscalYearFieldTitle()` Title for the `fiscal year` field in the date grid.
    `java.lang.String` | `getFiscalYearHeaderStyle()` Base CSS style applied to the header of the `fiscal year column` in the `calendar view`.
    `java.lang.Integer` | `getHeaderHeight()` Deprecated. in favor of `navigationLayoutHeight`
    `java.lang.String` | `getHeaderStyle()` CSS style applied to the day-of-week headers.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `IButton` | `getMonthChooserButton()` A button shown in the `navigation layout` that shows a picker for selecting a specific month.
    `java.lang.String` | `getMonthMenuStyle()` Style for the pop-up year menu.
    `HLayout` | `getNavigationLayout()` An `com.smartgwt.client.types.AutoChild` `HLayout`, rendered above the `date grid`, and showing a number of widgets for navigating the DateChooser.
    `int` | `getNavigationLayoutHeight()` Height of the `navigation area`, containing the various buttons for navigating the `calendar view`.
    `IButton` | `getNextMonthButton()` A button shown in the `navigation layout` that shifts the calendar view forward by a month.
    `java.lang.String` | `getNextMonthButtonAriaLabel()` `Aria label` for the `nextMonthButton`.
    `java.lang.String` | `getNextMonthIcon()` Icon for the next month button
    `int` | `getNextMonthIconHeight()` Height of the icon for the next month button
    `java.lang.String` | `getNextMonthIconRTL()` Icon for the next month button
    `int` | `getNextMonthIconWidth()` Width of the icon for the next month button if `Page.isRTL()` is true.
    `IButton` | `getNextYearButton()` A button shown in the `navigation layout` that shifts the calendar view forward by a year.
    `java.lang.String` | `getNextYearButtonAriaLabel()` `Aria label` for the `nextYearButton`.
    `java.lang.String` | `getNextYearIcon()` Icon for the next year button
    `int` | `getNextYearIconHeight()` Height of the icon for the next year button
    `java.lang.String` | `getNextYearIconRTL()` Icon for the next year button if `Page.isRTL()` is true.
    `int` | `getNextYearIconWidth()` Width of the icon for the next year button
    `static DateChooser` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `IButton` | `getPreviousMonthButton()` A button shown in the `navigation layout` that shifts the calendar view backward by a month.
    `java.lang.String` | `getPreviousMonthButtonAriaLabel()` `Aria label` for the `previousMonthButton`.
    `IButton` | `getPreviousYearButton()` A button shown in the `navigation layout` that shifts the calendar view backward by a year.
    `java.lang.String` | `getPreviousYearButtonAriaLabel()` `Aria label` for the `previousYearButton`.
    `java.lang.String` | `getPrevMonthIcon()` Icon for the previous month button
    `int` | `getPrevMonthIconHeight()` Height of the icon for the previous month button
    `java.lang.String` | `getPrevMonthIconRTL()` Icon for the previous month button if `Page.isRTL()` is true.
    `int` | `getPrevMonthIconWidth()` Width of the icon for the previous month button
    `java.lang.String` | `getPrevYearIcon()` Icon for the previous year button
    `int` | `getPrevYearIconHeight()` Height of the icon for the previous year button
    `java.lang.String` | `getPrevYearIconRTL()` Icon for the previous year button if `Page.isRTL()` is true.
    `int` | `getPrevYearIconWidth()` Width of the icon for the previous year button
    `java.lang.String` | `getSelectedWeekStyle()` CSS style applied to the Fiscal Year and Week columns for the currently selected week (the one being displayed in the `week chooser`).
    `java.lang.Boolean` | `getShowApplyButton()` Determines whether the `applyButton` will be displayed.
    `java.lang.Boolean` | `getShowCancelButton()` Determines whether the "Cancel" button will be displayed.
    `java.lang.Boolean` | `getShowFiscalYearChooser()` When set to true, show a button that allows the calendar to be navigated by fiscal year.
    `java.lang.Boolean` | `getShowSecondItem()` When showing the `time field`, whether to show the "second" picker.
    `java.lang.Boolean` | `getShowTimeItem()` Whether to show the `time field` for editing the time portion of the date.
    `java.lang.Boolean` | `getShowTodayButton()` Determines whether the "Today" button will be displayed, allowing the user to select the current date.
    `java.lang.Boolean` | `getShowWeekChooser()` When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showFiscalYearChooser`.
    `java.lang.Boolean` | `getShowWeekends()` Whether weekend days should be shown.
    `java.lang.String` | `getSkinImgDir()` Overridden directory where images for this widget (such as the month and year button icons) may be found.
    `int` | `getStartYear()` Earliest year that may be selected.
    `java.lang.Integer` | `getStartYearRange()` When `startYear` is unset, this is the years before today that will be available for selection in the year menu.
    `java.lang.Boolean` | `getStyleWeekends()` Whether weekend days should be styled differently from weekdays.
    `TimeItem` | `getTimeItem()` `TimeItem` for editing the time portion of dates.
    `TimeItem` | `getTimeItemProperties()` Custom properties to apply to the `time field` used for editing the time portion of the date.
    `java.lang.String` | `getTimeItemTitle()` Title for the `time field`.
    `IButton` | `getTodayButton()` A button shown below the `calendar grid` which, when clicked, navigates the calendar to today.
    `java.lang.Integer` | `getTodayButtonHeight()` If set specifies a fixed height for the Today and Cancel buttons.
    `java.lang.String` | `getTodayButtonTitle()` Title for "Today" button.
    `java.lang.Boolean` | `getUse24HourTime()` When showing the `time field`, whether the `TimeItem` should be set to use 24-hour time.
    `java.lang.Boolean` | `getUseFirstDayOfFiscalWeek()` When showing the `fiscal year chooser`, should firstDayOfWeek be defaulted to the same day as the fiscal start date? If true and a fiscal year starts on a Tuesday, the calendar will display Tuesday to Monday from left to right.
    `IButton` | `getWeekChooserButton()` A button shown in the `navigation layout` which shows a picker for selecting a specific week of the year.
    `int[]` | `getWeekendDays()` An array of integer day-numbers that should be considered to be weekend days by this DateChooser instance.
    `java.lang.String` | `getWeekendHeaderStyle()` Optional CSS style applied to the day-of-week headers for weekend days.
    `java.lang.String` | `getWeekFieldTitle()` Title for the `week` field in the date grid.
    `java.lang.String` | `getWeekHeaderStyle()` Base CSS style applied to the header of the `fiscal or calendar week column` in the `calendar view`.
    `java.lang.String` | `getWeekMenuStyle()` Style for the pop-up week menu.
    `IButton` | `getYearChooserButton()` A button shown in the `navigation layout` that shows a picker for selecting a specific calendar year.
    `java.lang.String` | `getYearMenuStyle()` Style for the pop-up year menu.
    `DateChooser` | `setAlternateStyleSuffix(java.lang.String alternateStyleSuffix)` The text appended to the style name when using `alternateWeekStyles`.
    `DateChooser` | `setAlternateWeekStyles(java.lang.Boolean alternateWeekStyles)` Whether alternating weeks should be drawn in alternating styles.
    `DateChooser` | `setApplyButtonTitle(java.lang.String applyButtonTitle)` Title for the `Apply` button.
    `DateChooser` | `setBaseBottomButtonStyle(java.lang.String baseBottomButtonStyle)` CSS style to apply to the buttons at the bottom of the DateChooser ("Today" and "Cancel").
    `DateChooser` | `setBaseButtonStyle(java.lang.String baseButtonStyle)` Base CSS style applied to this picker's buttons.
    `DateChooser` | `setBaseFiscalYearStyle(java.lang.String baseFiscalYearStyle)` Base CSS style applied to cells in the `fiscal year column`.
    `DateChooser` | `setBaseNavButtonStyle(java.lang.String baseNavButtonStyle)` CSS style to apply to navigation buttons and date display at the top of the component.
    `DateChooser` | `setBaseWeekdayStyle(java.lang.String baseWeekdayStyle)` Base CSS style applied to weekdays.
    `DateChooser` | `setBaseWeekendStyle(java.lang.String baseWeekendStyle)` Base CSS style applied to weekends.
    `DateChooser` | `setBaseWeekStyle(java.lang.String baseWeekStyle)` Base CSS style applied to cells in the `fiscal week column`.
    `DateChooser` | `setButtonLayoutControls(java.lang.String... buttonLayoutControls)` Array of members to show in the `buttonLayout`.
    `DateChooser` | `setCancelButtonTitle(java.lang.String cancelButtonTitle)` Title for the cancellation button.
    `DateChooser` | `setCloseOnDateClick(java.lang.Boolean closeOnDateClick)` When editing a "date" value, with no time portion, clicking on a date-cell selects the date and closes the DateChooser.
    `DateChooser` | `setCloseOnEscapeKeypress(boolean closeOnEscapeKeypress)` Should this dateChooser be dismissed if the user presses the Escape key?
    `void` | `setData(java.util.Date date)` Set the picker to show the given date.
    `DateChooser` | `setDayNameLength(int dayNameLength)` How long (how many characters) should be day names be.
    `static void` | `setDefaultProperties(DateChooser dateChooserProperties)` Class level method to set the default properties of this class.
    `DateChooser` | `setDisabledDates(java.util.Date... disabledDates)` An array of Date instances that should be disabled if they appear in the calendar view.
    `DateChooser` | `setDisabledWeekdayStyle(java.lang.String disabledWeekdayStyle)` Base CSS style applied to weekday dates which have been `disabled`.
    `DateChooser` | `setDisabledWeekendStyle(java.lang.String disabledWeekendStyle)` Base CSS style applied to weekend dates which have been `disabled`.
    `DateChooser` | `setDisableWeekends(java.lang.Boolean disableWeekends)` Whether it should be valid to pick a weekend day.
    `DateChooser` | `setEndYear(int endYear)` Latest year that may be selected.
    `DateChooser` | `setEndYearRange(java.lang.Integer endYearRange)` When `endYear` is unset, this is the years after today that will be available for selection in the year menu.
    `DateChooser` | `setFirstDayOfWeek(int firstDayOfWeek)` Day of the week to show in the first column.
    `void` | `setFiscalCalendar()` Sets the `FiscalCalendar` object that will be used by this DateChooser.
    `void` | `setFiscalCalendar(FiscalCalendar fiscalCalendar)` Sets the `FiscalCalendar` object that will be used by this DateChooser.
    `DateChooser` | `setFiscalYearFieldTitle(java.lang.String fiscalYearFieldTitle)` Title for the `fiscal year` field in the date grid.
    `DateChooser` | `setFiscalYearHeaderStyle(java.lang.String fiscalYearHeaderStyle)` Base CSS style applied to the header of the `fiscal year column` in the `calendar view`.
    `DateChooser` | `setHeaderHeight(java.lang.Integer headerHeight)` Deprecated. in favor of `navigationLayoutHeight`
    `DateChooser` | `setHeaderStyle(java.lang.String headerStyle)` CSS style applied to the day-of-week headers.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.DateChooserLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `DateChooser` | `setMonthMenuStyle(java.lang.String monthMenuStyle)` Style for the pop-up year menu.
    `DateChooser` | `setNavigationLayoutHeight(int navigationLayoutHeight)` Height of the `navigation area`, containing the various buttons for navigating the `calendar view`.
    `DateChooser` | `setNextMonthButtonAriaLabel(java.lang.String nextMonthButtonAriaLabel)` `Aria label` for the `nextMonthButton`.
    `DateChooser` | `setNextMonthIcon(java.lang.String nextMonthIcon)` Icon for the next month button
    `DateChooser` | `setNextMonthIconHeight(int nextMonthIconHeight)` Height of the icon for the next month button
    `DateChooser` | `setNextMonthIconRTL(java.lang.String nextMonthIconRTL)` Icon for the next month button
    `DateChooser` | `setNextMonthIconWidth(int nextMonthIconWidth)` Width of the icon for the next month button if `Page.isRTL()` is true.
    `DateChooser` | `setNextYearButtonAriaLabel(java.lang.String nextYearButtonAriaLabel)` `Aria label` for the `nextYearButton`.
    `DateChooser` | `setNextYearIcon(java.lang.String nextYearIcon)` Icon for the next year button
    `DateChooser` | `setNextYearIconHeight(int nextYearIconHeight)` Height of the icon for the next year button
    `DateChooser` | `setNextYearIconRTL(java.lang.String nextYearIconRTL)` Icon for the next year button if `Page.isRTL()` is true.
    `DateChooser` | `setNextYearIconWidth(int nextYearIconWidth)` Width of the icon for the next year button
    `DateChooser` | `setPreviousMonthButtonAriaLabel(java.lang.String previousMonthButtonAriaLabel)` `Aria label` for the `previousMonthButton`.
    `DateChooser` | `setPreviousYearButtonAriaLabel(java.lang.String previousYearButtonAriaLabel)` `Aria label` for the `previousYearButton`.
    `DateChooser` | `setPrevMonthIcon(java.lang.String prevMonthIcon)` Icon for the previous month button
    `DateChooser` | `setPrevMonthIconHeight(int prevMonthIconHeight)` Height of the icon for the previous month button
    `DateChooser` | `setPrevMonthIconRTL(java.lang.String prevMonthIconRTL)` Icon for the previous month button if `Page.isRTL()` is true.
    `DateChooser` | `setPrevMonthIconWidth(int prevMonthIconWidth)` Width of the icon for the previous month button
    `DateChooser` | `setPrevYearIcon(java.lang.String prevYearIcon)` Icon for the previous year button
    `DateChooser` | `setPrevYearIconHeight(int prevYearIconHeight)` Height of the icon for the previous year button
    `DateChooser` | `setPrevYearIconRTL(java.lang.String prevYearIconRTL)` Icon for the previous year button if `Page.isRTL()` is true.
    `DateChooser` | `setPrevYearIconWidth(int prevYearIconWidth)` Width of the icon for the previous year button
    `DateChooser` | `setSelectedWeekStyle(java.lang.String selectedWeekStyle)` CSS style applied to the Fiscal Year and Week columns for the currently selected week (the one being displayed in the `week chooser`).
    `DateChooser` | `setShowApplyButton(java.lang.Boolean showApplyButton)` Determines whether the `applyButton` will be displayed.
    `DateChooser` | `setShowCancelButton(java.lang.Boolean showCancelButton)` Determines whether the "Cancel" button will be displayed.
    `DateChooser` | `setShowFiscalYearChooser(java.lang.Boolean showFiscalYearChooser)` When set to true, show a button that allows the calendar to be navigated by fiscal year.
    `DateChooser` | `setShowSecondItem(java.lang.Boolean showSecondItem)` When showing the `time field`, whether to show the "second" picker.
    `DateChooser` | `setShowTimeItem(java.lang.Boolean showTimeItem)` Whether to show the `time field` for editing the time portion of the date.
    `DateChooser` | `setShowTodayButton(java.lang.Boolean showTodayButton)` Determines whether the "Today" button will be displayed, allowing the user to select the current date.
    `DateChooser` | `setShowWeekChooser(java.lang.Boolean showWeekChooser)` When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showFiscalYearChooser`.
    `DateChooser` | `setShowWeekends(java.lang.Boolean showWeekends)` Whether weekend days should be shown.
    `DateChooser` | `setSkinImgDir(java.lang.String skinImgDir)` Overridden directory where images for this widget (such as the month and year button icons) may be found.
    `DateChooser` | `setStartYear(int startYear)` Earliest year that may be selected.
    `DateChooser` | `setStartYearRange(java.lang.Integer startYearRange)` When `startYear` is unset, this is the years before today that will be available for selection in the year menu.
    `DateChooser` | `setStyleWeekends(java.lang.Boolean styleWeekends)` Whether weekend days should be styled differently from weekdays.
    `DateChooser` | `setTimeItemProperties(TimeItem timeItemProperties)` Custom properties to apply to the `time field` used for editing the time portion of the date.
    `DateChooser` | `setTimeItemTitle(java.lang.String timeItemTitle)` Title for the `time field`.
    `DateChooser` | `setTodayButtonHeight(java.lang.Integer todayButtonHeight)` If set specifies a fixed height for the Today and Cancel buttons.
    `DateChooser` | `setTodayButtonTitle(java.lang.String todayButtonTitle)` Title for "Today" button.
    `DateChooser` | `setUse24HourTime(java.lang.Boolean use24HourTime)` When showing the `time field`, whether the `TimeItem` should be set to use 24-hour time.
    `DateChooser` | `setUseFirstDayOfFiscalWeek(java.lang.Boolean useFirstDayOfFiscalWeek)` When showing the `fiscal year chooser`, should firstDayOfWeek be defaulted to the same day as the fiscal start date? If true and a fiscal year starts on a Tuesday, the calendar will display Tuesday to Monday from left to right.
    `DateChooser` | `setWeekendDays(int... weekendDays)` An array of integer day-numbers that should be considered to be weekend days by this DateChooser instance.
    `DateChooser` | `setWeekendHeaderStyle(java.lang.String weekendHeaderStyle)` Optional CSS style applied to the day-of-week headers for weekend days.
    `DateChooser` | `setWeekFieldTitle(java.lang.String weekFieldTitle)` Title for the `week` field in the date grid.
    `DateChooser` | `setWeekHeaderStyle(java.lang.String weekHeaderStyle)` Base CSS style applied to the header of the `fiscal or calendar week column` in the `calendar view`.
    `DateChooser` | `setWeekMenuStyle(java.lang.String weekMenuStyle)` Style for the pop-up week menu.
    `DateChooser` | `setYearMenuStyle(java.lang.String yearMenuStyle)` Style for the pop-up year menu.
    `void` | `setYearTitleFormatter(DateChooser.YearTitleFormatter formatter)`
    `void` | `todayClick()` Fired when the user clicks the Today button.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, dataContextChanged, deparent, depeer, disable, enable, encloses, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCorrectZoomOverflow, getCursor, getDataContext, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSizeMayChangeOnRedraw, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getTabIndex, getTestDataContext, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUISummary, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDragMask, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSizeMayChangeOnRedraw, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDragMask, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DateChooser

          public DateChooser()

    - #### DateChooser

          public DateChooser(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DateChooser getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `VLayout`

    - #### setAlternateStyleSuffix

          public DateChooser setAlternateStyleSuffix(java.lang.String alternateStyleSuffix)

      The text appended to the style name when using `alternateWeekStyles`.
      Parameters:
        `alternateStyleSuffix` - New alternateStyleSuffix value. Default value is "Dark"
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getAlternateStyleSuffix

          public java.lang.String getAlternateStyleSuffix()

      The text appended to the style name when using `alternateWeekStyles`.
      Returns:
        Current alternateStyleSuffix value. Default value is "Dark"

    - #### setAlternateWeekStyles

          public DateChooser setAlternateWeekStyles(java.lang.Boolean alternateWeekStyles)

      Whether alternating weeks should be drawn in alternating styles. If enabled, the cell style for alternate rows will have `alternateStyleSuffix` appended to it.
      Parameters:
        `alternateWeekStyles` - New alternateWeekStyles value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getAlternateWeekStyles

          public java.lang.Boolean getAlternateWeekStyles()

      Whether alternating weeks should be drawn in alternating styles. If enabled, the cell style for alternate rows will have `alternateStyleSuffix` appended to it.
      Returns:
        Current alternateWeekStyles value. Default value is null

    - #### getApplyButton

          public IButton getApplyButton()
                                 throws java.lang.IllegalStateException

      When a DateChooser is configured for `a "datetime" value`, clicking on a date cell in the `grid` will not automatically dismiss the DateChooser canvas. In this case, use the `Apply` button to accept the selected date and time and dismiss the chooser.

      This component is an AutoChild named "applyButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current applyButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setApplyButtonTitle

          public DateChooser setApplyButtonTitle(java.lang.String applyButtonTitle)

      Title for the `Apply` button.
      Parameters:
        `applyButtonTitle` - New applyButtonTitle value. Default value is "Apply"
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getApplyButtonTitle

          public java.lang.String getApplyButtonTitle()

      Title for the `Apply` button.
      Returns:
        Current applyButtonTitle value. Default value is "Apply"

    - #### setBaseBottomButtonStyle

          public DateChooser setBaseBottomButtonStyle(java.lang.String baseBottomButtonStyle)

      CSS style to apply to the buttons at the bottom of the DateChooser ("Today" and "Cancel"). If null, the CSS style specified in `baseButtonStyle` is used.
      Parameters:
        `baseBottomButtonStyle` - New baseBottomButtonStyle value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getBaseBottomButtonStyle

          public java.lang.String getBaseBottomButtonStyle()

      CSS style to apply to the buttons at the bottom of the DateChooser ("Today" and "Cancel"). If null, the CSS style specified in `baseButtonStyle` is used.
      Returns:
        Current baseBottomButtonStyle value. Default value is null
      See Also:
        `CSSStyleName`

    - #### setBaseButtonStyle

          public DateChooser setBaseButtonStyle(java.lang.String baseButtonStyle)

      Base CSS style applied to this picker's buttons. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Parameters:
        `baseButtonStyle` - New baseButtonStyle value. Default value is "dateChooserButton"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getBaseButtonStyle

          public java.lang.String getBaseButtonStyle()

      Base CSS style applied to this picker's buttons. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Returns:
        Current baseButtonStyle value. Default value is "dateChooserButton"
      See Also:
        `CSSStyleName`

    - #### setBaseFiscalYearStyle

          public DateChooser setBaseFiscalYearStyle(java.lang.String baseFiscalYearStyle)

      Base CSS style applied to cells in the `fiscal year column`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Parameters:
        `baseFiscalYearStyle` - New baseFiscalYearStyle value. Default value is "dateChooserFiscalYearCell"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getBaseFiscalYearStyle

          public java.lang.String getBaseFiscalYearStyle()

      Base CSS style applied to cells in the `fiscal year column`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Returns:
        Current baseFiscalYearStyle value. Default value is "dateChooserFiscalYearCell"
      See Also:
        `CSSStyleName`

    - #### setBaseNavButtonStyle

          public DateChooser setBaseNavButtonStyle(java.lang.String baseNavButtonStyle)

      CSS style to apply to navigation buttons and date display at the top of the component. If null, the CSS style specified in `baseButtonStyle` is used.
      Parameters:
        `baseNavButtonStyle` - New baseNavButtonStyle value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getBaseNavButtonStyle

          public java.lang.String getBaseNavButtonStyle()

      CSS style to apply to navigation buttons and date display at the top of the component. If null, the CSS style specified in `baseButtonStyle` is used.
      Returns:
        Current baseNavButtonStyle value. Default value is null
      See Also:
        `CSSStyleName`

    - #### setBaseWeekdayStyle

          public DateChooser setBaseWeekdayStyle(java.lang.String baseWeekdayStyle)

      Base CSS style applied to weekdays. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons. Defaults to `baseButtonStyle`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Parameters:
        `baseWeekdayStyle` - New baseWeekdayStyle value. Default value is "dateChooserWeekday"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getBaseWeekdayStyle

          public java.lang.String getBaseWeekdayStyle()

      Base CSS style applied to weekdays. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons. Defaults to `baseButtonStyle`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Returns:
        Current baseWeekdayStyle value. Default value is "dateChooserWeekday"
      See Also:
        `CSSStyleName`

    - #### setBaseWeekendStyle

          public DateChooser setBaseWeekendStyle(java.lang.String baseWeekendStyle)

      Base CSS style applied to weekends. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons. Defaults to `baseWeekdayStyle`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Parameters:
        `baseWeekendStyle` - New baseWeekendStyle value. Default value is "dateChooserWeekend"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getBaseWeekendStyle

          public java.lang.String getBaseWeekendStyle()

      Base CSS style applied to weekends. Will have "Over", "Selected" and "Down" suffix appended as the user interacts with buttons. Defaults to `baseWeekdayStyle`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles in Grids.

      Returns:
        Current baseWeekendStyle value. Default value is "dateChooserWeekend"
      See Also:
        `CSSStyleName`

    - #### setBaseWeekStyle

          public DateChooser setBaseWeekStyle(java.lang.String baseWeekStyle)

      Base CSS style applied to cells in the `fiscal week column`.
      Parameters:
        `baseWeekStyle` - New baseWeekStyle value. Default value is "dateChooserWeekCell"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getBaseWeekStyle

          public java.lang.String getBaseWeekStyle()

      Base CSS style applied to cells in the `fiscal week column`.
      Returns:
        Current baseWeekStyle value. Default value is "dateChooserWeekCell"
      See Also:
        `CSSStyleName`

    - #### getButtonLayout

          public HLayout getButtonLayout()
                                  throws java.lang.IllegalStateException

      An `com.smartgwt.client.types.AutoChild` `HLayout`, rendered below the `date grid`, and showing the `Today`, `Cancel` and, when working with "datetime" values, `Apply` buttons.

      This component is an AutoChild named "buttonLayout". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current buttonLayout value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setButtonLayoutControls

          public DateChooser setButtonLayoutControls(java.lang.String... buttonLayoutControls)
                                              throws java.lang.IllegalStateException

      Array of members to show in the `buttonLayout`.

      The default value of `buttonLayoutControls` is an Array of Strings listing the standard buttons in their default order:

               buttonLayoutControls : ["todayButton", "cancelButton", "applyButton"]

      You can override `buttonLayoutControls` to change the order of the standard buttons. You can also omit standard buttons this way, although it's more efficient to use the related "show" property if available (eg `showTodayButton`).

      By embedding a Canvas directly in this list you can add arbitrary additional controls to the buttonLayout.

      Note that having added controls to buttonLayoutControls, you can still call APIs directly on those controls to change their appearance, and you can also show() and hide() them if they should not be shown in some circumstances.

      Tip: custom controls need to set layoutAlign:"center" to appear vertically centered.

      Parameters:
        `buttonLayoutControls` - New buttonLayoutControls value. Default value is (see below)
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getButtonLayoutControls

          public java.lang.String[] getButtonLayoutControls()

      Array of members to show in the `buttonLayout`.

      The default value of `buttonLayoutControls` is an Array of Strings listing the standard buttons in their default order:

               buttonLayoutControls : ["todayButton", "cancelButton", "applyButton"]

      You can override `buttonLayoutControls` to change the order of the standard buttons. You can also omit standard buttons this way, although it's more efficient to use the related "show" property if available (eg `showTodayButton`).

      By embedding a Canvas directly in this list you can add arbitrary additional controls to the buttonLayout.

      Note that having added controls to buttonLayoutControls, you can still call APIs directly on those controls to change their appearance, and you can also show() and hide() them if they should not be shown in some circumstances.

      Tip: custom controls need to set layoutAlign:"center" to appear vertically centered.

      Returns:
        Current buttonLayoutControls value. Default value is (see below)

    - #### getCancelButton

          public IButton getCancelButton()
                                  throws java.lang.IllegalStateException

      A button shown below the `calendar grid` which, when clicked, closes the DateChooser without selecting a value.

      This component is an AutoChild named "cancelButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current cancelButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setCancelButtonTitle

          public DateChooser setCancelButtonTitle(java.lang.String cancelButtonTitle)

      Title for the cancellation button.
      Parameters:
        `cancelButtonTitle` - New cancelButtonTitle value. Default value is "Cancel"
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getCancelButtonTitle

          public java.lang.String getCancelButtonTitle()

      Title for the cancellation button.
      Returns:
        Current cancelButtonTitle value. Default value is "Cancel"

    - #### setCloseOnDateClick

          public DateChooser setCloseOnDateClick(java.lang.Boolean closeOnDateClick)

      When editing a "date" value, with no time portion, clicking on a date-cell selects the date and closes the DateChooser. When a `time portion` is required, however, the `apply button` must be clicked to close the chooser, by default.

      Set this attribute to true to have the DateChooser close when a user clicks in a date-cell, even if the `timeItem` is showing.

      Parameters:
        `closeOnDateClick` - New closeOnDateClick value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getCloseOnDateClick

          public java.lang.Boolean getCloseOnDateClick()

      When editing a "date" value, with no time portion, clicking on a date-cell selects the date and closes the DateChooser. When a `time portion` is required, however, the `apply button` must be clicked to close the chooser, by default.

      Set this attribute to true to have the DateChooser close when a user clicks in a date-cell, even if the `timeItem` is showing.

      Returns:
        Current closeOnDateClick value. Default value is null

    - #### setCloseOnEscapeKeypress

          public DateChooser setCloseOnEscapeKeypress(boolean closeOnEscapeKeypress)
                                               throws java.lang.IllegalStateException

      Should this dateChooser be dismissed if the user presses the Escape key?
      Parameters:
        `closeOnEscapeKeypress` - New closeOnEscapeKeypress value. Default value is false
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getCloseOnEscapeKeypress

          public boolean getCloseOnEscapeKeypress()

      Should this dateChooser be dismissed if the user presses the Escape key?
      Returns:
        Current closeOnEscapeKeypress value. Default value is false

    - #### getDateGrid

          public DateGrid getDateGrid()
                               throws java.lang.IllegalStateException

      A `ListGrid` subclass, responsible for rendering the calendar view.

      This component is an AutoChild named "dateGrid". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current dateGrid value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setDayNameLength

          public DateChooser setDayNameLength(int dayNameLength)
                                       throws java.lang.IllegalStateException

      How long (how many characters) should be day names be. May be 1, 2 or 3 characters.
      Parameters:
        `dayNameLength` - New dayNameLength value. Default value is 2
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDayNameLength

          public int getDayNameLength()

      How long (how many characters) should be day names be. May be 1, 2 or 3 characters.
      Returns:
        Current dayNameLength value. Default value is 2

    - #### setDisabledDates

          public DateChooser setDisabledDates(java.util.Date... disabledDates)

      An array of Date instances that should be disabled if they appear in the calendar view.
      Parameters:
        `disabledDates` - New disabledDates value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getDisabledDates

          public java.util.Date[] getDisabledDates()

      An array of Date instances that should be disabled if they appear in the calendar view.
      Returns:
        Current disabledDates value. Default value is null

    - #### setDisabledWeekdayStyle

          public DateChooser setDisabledWeekdayStyle(java.lang.String disabledWeekdayStyle)

      Base CSS style applied to weekday dates which have been `disabled`.
      Parameters:
        `disabledWeekdayStyle` - New disabledWeekdayStyle value. Default value is "dateChooserDisabledWeekday"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getDisabledWeekdayStyle

          public java.lang.String getDisabledWeekdayStyle()

      Base CSS style applied to weekday dates which have been `disabled`.
      Returns:
        Current disabledWeekdayStyle value. Default value is "dateChooserDisabledWeekday"
      See Also:
        `CSSStyleName`

    - #### setDisabledWeekendStyle

          public DateChooser setDisabledWeekendStyle(java.lang.String disabledWeekendStyle)

      Base CSS style applied to weekend dates which have been `disabled`.
      Parameters:
        `disabledWeekendStyle` - New disabledWeekendStyle value. Default value is "dateChooserDisabledWeekend"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getDisabledWeekendStyle

          public java.lang.String getDisabledWeekendStyle()

      Base CSS style applied to weekend dates which have been `disabled`.
      Returns:
        Current disabledWeekendStyle value. Default value is "dateChooserDisabledWeekend"
      See Also:
        `CSSStyleName`

    - #### setDisableWeekends

          public DateChooser setDisableWeekends(java.lang.Boolean disableWeekends)
                                         throws java.lang.IllegalStateException

      Whether it should be valid to pick a weekend day. If set to true, weekend days appear in disabled style and cannot be picked.

      Which days are considered weekends is controlled by `weekendDays` if set or by `weekendDays` otherwise.

      Parameters:
        `disableWeekends` - New disableWeekends value. Default value is false
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getDisableWeekends

          public java.lang.Boolean getDisableWeekends()

      Whether it should be valid to pick a weekend day. If set to true, weekend days appear in disabled style and cannot be picked.

      Which days are considered weekends is controlled by `weekendDays` if set or by `weekendDays` otherwise.

      Returns:
        Current disableWeekends value. Default value is false

    - #### setEndYear

          public DateChooser setEndYear(int endYear)
                                 throws java.lang.IllegalStateException

      Latest year that may be selected. If this chooser was opened by a `DateItem`, the default is inherited from `DateItem.endDate`. Otherwise, the default is 5 years after today.

      When opened from a `RelativeDateItem`, this property and `startYear` are defaulted to null, and the year-picker shows years surrounding the current year, according to `startYearRange` and `endYearRange`.

      Parameters:
        `endYear` - New endYear value. Default value is 2025
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getEndYear

          public int getEndYear()

      Latest year that may be selected. If this chooser was opened by a `DateItem`, the default is inherited from `DateItem.endDate`. Otherwise, the default is 5 years after today.

      When opened from a `RelativeDateItem`, this property and `startYear` are defaulted to null, and the year-picker shows years surrounding the current year, according to `startYearRange` and `endYearRange`.

      Returns:
        Current endYear value. Default value is 2025

    - #### setEndYearRange

          public DateChooser setEndYearRange(java.lang.Integer endYearRange)
                                      throws java.lang.IllegalStateException

      When `endYear` is unset, this is the years after today that will be available for selection in the year menu.
      Parameters:
        `endYearRange` - New endYearRange value. Default value is 10
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getEndYearRange

          public java.lang.Integer getEndYearRange()

      When `endYear` is unset, this is the years after today that will be available for selection in the year menu.
      Returns:
        Current endYearRange value. Default value is 10

    - #### setFirstDayOfWeek

          public DateChooser setFirstDayOfWeek(int firstDayOfWeek)
                                        throws java.lang.IllegalStateException

      Day of the week to show in the first column. 0=Sunday, 1=Monday, ..., 6=Saturday. The default value for this attribute is picked up from the current locale and can also be altered system-wide with the `global setter`.
      Parameters:
        `firstDayOfWeek` - New firstDayOfWeek value. Default value is 0
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getFirstDayOfWeek

          public int getFirstDayOfWeek()

      Day of the week to show in the first column. 0=Sunday, 1=Monday, ..., 6=Saturday. The default value for this attribute is picked up from the current locale and can also be altered system-wide with the `global setter`.
      Returns:
        Current firstDayOfWeek value. Default value is 0
      See Also:
        `Appearance overview and related methods`

    - #### getFiscalYearChooserButton

          public IButton getFiscalYearChooserButton()
                                             throws java.lang.IllegalStateException

      A button shown in the `navigation layout` which, when clicked, shows a picker for selecting a specific fiscal year.

      This component is an AutoChild named "fiscalYearChooserButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current fiscalYearChooserButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setFiscalYearFieldTitle

          public DateChooser setFiscalYearFieldTitle(java.lang.String fiscalYearFieldTitle)

      Title for the `fiscal year` field in the date grid.
      Parameters:
        `fiscalYearFieldTitle` - New fiscalYearFieldTitle value. Default value is "Year"
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getFiscalYearFieldTitle

          public java.lang.String getFiscalYearFieldTitle()

      Title for the `fiscal year` field in the date grid.
      Returns:
        Current fiscalYearFieldTitle value. Default value is "Year"

    - #### setFiscalYearHeaderStyle

          public DateChooser setFiscalYearHeaderStyle(java.lang.String fiscalYearHeaderStyle)

      Base CSS style applied to the header of the `fiscal year column` in the `calendar view`.
      Parameters:
        `fiscalYearHeaderStyle` - New fiscalYearHeaderStyle value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getFiscalYearHeaderStyle

          public java.lang.String getFiscalYearHeaderStyle()

      Base CSS style applied to the header of the `fiscal year column` in the `calendar view`.
      Returns:
        Current fiscalYearHeaderStyle value. Default value is null
      See Also:
        `CSSStyleName`

    - #### setHeaderHeight

          public DateChooser setHeaderHeight(java.lang.Integer headerHeight)
                                      throws java.lang.IllegalStateException

      Deprecated. in favor of `navigationLayoutHeight`
      Height of the header area (containing the navigation buttons) in pixels.
      Parameters:
        `headerHeight` - New headerHeight value. Default value is 20
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getHeaderHeight

          public java.lang.Integer getHeaderHeight()

      Deprecated. in favor of `navigationLayoutHeight`
      Height of the header area (containing the navigation buttons) in pixels.
      Returns:
        Current headerHeight value. Default value is 20

    - #### setHeaderStyle

          public DateChooser setHeaderStyle(java.lang.String headerStyle)

      CSS style applied to the day-of-week headers. By default this applies to all days of the week. To apply a separate style to weekend headers, set `weekendHeaderStyle`
      Parameters:
        `headerStyle` - New headerStyle value. Default value is "dateChooserButtonDisabled"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getHeaderStyle

          public java.lang.String getHeaderStyle()

      CSS style applied to the day-of-week headers. By default this applies to all days of the week. To apply a separate style to weekend headers, set `weekendHeaderStyle`
      Returns:
        Current headerStyle value. Default value is "dateChooserButtonDisabled"
      See Also:
        `CSSStyleName`

    - #### getMonthChooserButton

          public IButton getMonthChooserButton()
                                        throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shows a picker for selecting a specific month.

      This component is an AutoChild named "monthChooserButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current monthChooserButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setMonthMenuStyle

          public DateChooser setMonthMenuStyle(java.lang.String monthMenuStyle)
                                        throws java.lang.IllegalStateException

      Style for the pop-up year menu.
      Parameters:
        `monthMenuStyle` - New monthMenuStyle value. Default value is "dateChooserMonthMenu"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `CSSStyleName`

    - #### getMonthMenuStyle

          public java.lang.String getMonthMenuStyle()

      Style for the pop-up year menu.
      Returns:
        Current monthMenuStyle value. Default value is "dateChooserMonthMenu"
      See Also:
        `CSSStyleName`

    - #### getNavigationLayout

          public HLayout getNavigationLayout()
                                      throws java.lang.IllegalStateException

      An `com.smartgwt.client.types.AutoChild` `HLayout`, rendered above the `date grid`, and showing a number of widgets for navigating the DateChooser. These include buttons for moving to the previous `year` or `month`, the next `year` or `month`, and for selecting a specific `year`, `month` or `week`.

      This component is an AutoChild named "navigationLayout". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current navigationLayout value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setNavigationLayoutHeight

          public DateChooser setNavigationLayoutHeight(int navigationLayoutHeight)
                                                throws java.lang.IllegalStateException

      Height of the `navigation area`, containing the various buttons for navigating the `calendar view`.
      Parameters:
        `navigationLayoutHeight` - New navigationLayoutHeight value. Default value is 20
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getNavigationLayoutHeight

          public int getNavigationLayoutHeight()

      Height of the `navigation area`, containing the various buttons for navigating the `calendar view`.
      Returns:
        Current navigationLayoutHeight value. Default value is 20

    - #### getNextMonthButton

          public IButton getNextMonthButton()
                                     throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shifts the calendar view forward by a month.

      This component is an AutoChild named "nextMonthButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current nextMonthButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setNextMonthButtonAriaLabel

          public DateChooser setNextMonthButtonAriaLabel(java.lang.String nextMonthButtonAriaLabel)
                                                  throws java.lang.IllegalStateException

      `Aria label` for the `nextMonthButton`.
      Parameters:
        `nextMonthButtonAriaLabel` - New nextMonthButtonAriaLabel value. Default value is "Next month"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getNextMonthButtonAriaLabel

          public java.lang.String getNextMonthButtonAriaLabel()

      `Aria label` for the `nextMonthButton`.
      Returns:
        Current nextMonthButtonAriaLabel value. Default value is "Next month"

    - #### setNextMonthIcon

          public DateChooser setNextMonthIcon(java.lang.String nextMonthIcon)

      Icon for the next month button
      Parameters:
        `nextMonthIcon` - New nextMonthIcon value. Default value is "[SKIN]arrow_right.gif"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `URL`

    - #### getNextMonthIcon

          public java.lang.String getNextMonthIcon()

      Icon for the next month button
      Returns:
        Current nextMonthIcon value. Default value is "[SKIN]arrow_right.gif"
      See Also:
        `URL`

    - #### setNextMonthIconHeight

          public DateChooser setNextMonthIconHeight(int nextMonthIconHeight)

      Height of the icon for the next month button
      Parameters:
        `nextMonthIconHeight` - New nextMonthIconHeight value. Default value is 7
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getNextMonthIconHeight

          public int getNextMonthIconHeight()

      Height of the icon for the next month button
      Returns:
        Current nextMonthIconHeight value. Default value is 7

    - #### setNextMonthIconRTL

          public DateChooser setNextMonthIconRTL(java.lang.String nextMonthIconRTL)

      Icon for the next month button
      Parameters:
        `nextMonthIconRTL` - New nextMonthIconRTL value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `URL`

    - #### getNextMonthIconRTL

          public java.lang.String getNextMonthIconRTL()

      Icon for the next month button
      Returns:
        Current nextMonthIconRTL value. Default value is null
      See Also:
        `URL`

    - #### setNextMonthIconWidth

          public DateChooser setNextMonthIconWidth(int nextMonthIconWidth)

      Width of the icon for the next month button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextMonthIcon` will be used in place of the `prevMonthIcon` and vice versa.
      Parameters:
        `nextMonthIconWidth` - New nextMonthIconWidth value. Default value is 7
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getNextMonthIconWidth

          public int getNextMonthIconWidth()

      Width of the icon for the next month button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextMonthIcon` will be used in place of the `prevMonthIcon` and vice versa.
      Returns:
        Current nextMonthIconWidth value. Default value is 7

    - #### getNextYearButton

          public IButton getNextYearButton()
                                    throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shifts the calendar view forward by a year.

      This component is an AutoChild named "nextYearButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current nextYearButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setNextYearButtonAriaLabel

          public DateChooser setNextYearButtonAriaLabel(java.lang.String nextYearButtonAriaLabel)
                                                 throws java.lang.IllegalStateException

      `Aria label` for the `nextYearButton`.
      Parameters:
        `nextYearButtonAriaLabel` - New nextYearButtonAriaLabel value. Default value is "Next year"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getNextYearButtonAriaLabel

          public java.lang.String getNextYearButtonAriaLabel()

      `Aria label` for the `nextYearButton`.
      Returns:
        Current nextYearButtonAriaLabel value. Default value is "Next year"

    - #### setNextYearIcon

          public DateChooser setNextYearIcon(java.lang.String nextYearIcon)
                                      throws java.lang.IllegalStateException

      Icon for the next year button
      Parameters:
        `nextYearIcon` - New nextYearIcon value. Default value is "[SKIN]doubleArrow_right.gif"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.DateChooser#setShowDoubleYearIcon`, `URL`

    - #### getNextYearIcon

          public java.lang.String getNextYearIcon()

      Icon for the next year button
      Returns:
        Current nextYearIcon value. Default value is "[SKIN]doubleArrow_right.gif"
      See Also:
        `com.smartgwt.client.widgets.DateChooser#getShowDoubleYearIcon`, `URL`

    - #### setNextYearIconHeight

          public DateChooser setNextYearIconHeight(int nextYearIconHeight)

      Height of the icon for the next year button
      Parameters:
        `nextYearIconHeight` - New nextYearIconHeight value. Default value is 7
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getNextYearIconHeight

          public int getNextYearIconHeight()

      Height of the icon for the next year button
      Returns:
        Current nextYearIconHeight value. Default value is 7

    - #### setNextYearIconRTL

          public DateChooser setNextYearIconRTL(java.lang.String nextYearIconRTL)
                                         throws java.lang.IllegalStateException

      Icon for the next year button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextYearIcon` will be used in place of the `prevYearIcon` and vice versa.
      Parameters:
        `nextYearIconRTL` - New nextYearIconRTL value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.DateChooser#setShowDoubleYearIcon`, `URL`

    - #### getNextYearIconRTL

          public java.lang.String getNextYearIconRTL()

      Icon for the next year button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextYearIcon` will be used in place of the `prevYearIcon` and vice versa.
      Returns:
        Current nextYearIconRTL value. Default value is null
      See Also:
        `com.smartgwt.client.widgets.DateChooser#getShowDoubleYearIcon`, `URL`

    - #### setNextYearIconWidth

          public DateChooser setNextYearIconWidth(int nextYearIconWidth)
                                           throws java.lang.IllegalStateException

      Width of the icon for the next year button
      Parameters:
        `nextYearIconWidth` - New nextYearIconWidth value. Default value is 14
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getNextYearIconWidth

          public int getNextYearIconWidth()

      Width of the icon for the next year button
      Returns:
        Current nextYearIconWidth value. Default value is 14

    - #### getPreviousMonthButton

          public IButton getPreviousMonthButton()
                                         throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shifts the calendar view backward by a month.

      This component is an AutoChild named "previousMonthButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current previousMonthButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setPreviousMonthButtonAriaLabel

          public DateChooser setPreviousMonthButtonAriaLabel(java.lang.String previousMonthButtonAriaLabel)
                                                      throws java.lang.IllegalStateException

      `Aria label` for the `previousMonthButton`.
      Parameters:
        `previousMonthButtonAriaLabel` - New previousMonthButtonAriaLabel value. Default value is "Previous month"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPreviousMonthButtonAriaLabel

          public java.lang.String getPreviousMonthButtonAriaLabel()

      `Aria label` for the `previousMonthButton`.
      Returns:
        Current previousMonthButtonAriaLabel value. Default value is "Previous month"

    - #### getPreviousYearButton

          public IButton getPreviousYearButton()
                                        throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shifts the calendar view backward by a year.

      This component is an AutoChild named "previousYearButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current previousYearButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setPreviousYearButtonAriaLabel

          public DateChooser setPreviousYearButtonAriaLabel(java.lang.String previousYearButtonAriaLabel)
                                                     throws java.lang.IllegalStateException

      `Aria label` for the `previousYearButton`.
      Parameters:
        `previousYearButtonAriaLabel` - New previousYearButtonAriaLabel value. Default value is "Previous year"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPreviousYearButtonAriaLabel

          public java.lang.String getPreviousYearButtonAriaLabel()

      `Aria label` for the `previousYearButton`.
      Returns:
        Current previousYearButtonAriaLabel value. Default value is "Previous year"

    - #### setPrevMonthIcon

          public DateChooser setPrevMonthIcon(java.lang.String prevMonthIcon)
                                       throws java.lang.IllegalStateException

      Icon for the previous month button
      Parameters:
        `prevMonthIcon` - New prevMonthIcon value. Default value is "[SKIN]arrow_left.gif"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `URL`

    - #### getPrevMonthIcon

          public java.lang.String getPrevMonthIcon()

      Icon for the previous month button
      Returns:
        Current prevMonthIcon value. Default value is "[SKIN]arrow_left.gif"
      See Also:
        `URL`

    - #### setPrevMonthIconHeight

          public DateChooser setPrevMonthIconHeight(int prevMonthIconHeight)
                                             throws java.lang.IllegalStateException

      Height of the icon for the previous month button
      Parameters:
        `prevMonthIconHeight` - New prevMonthIconHeight value. Default value is 7
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevMonthIconHeight

          public int getPrevMonthIconHeight()

      Height of the icon for the previous month button
      Returns:
        Current prevMonthIconHeight value. Default value is 7

    - #### setPrevMonthIconRTL

          public DateChooser setPrevMonthIconRTL(java.lang.String prevMonthIconRTL)
                                          throws java.lang.IllegalStateException

      Icon for the previous month button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextMonthIcon` will be used in place of the `prevMonthIcon` and vice versa.
      Parameters:
        `prevMonthIconRTL` - New prevMonthIconRTL value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `URL`

    - #### getPrevMonthIconRTL

          public java.lang.String getPrevMonthIconRTL()

      Icon for the previous month button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextMonthIcon` will be used in place of the `prevMonthIcon` and vice versa.
      Returns:
        Current prevMonthIconRTL value. Default value is null
      See Also:
        `URL`

    - #### setPrevMonthIconWidth

          public DateChooser setPrevMonthIconWidth(int prevMonthIconWidth)
                                            throws java.lang.IllegalStateException

      Width of the icon for the previous month button
      Parameters:
        `prevMonthIconWidth` - New prevMonthIconWidth value. Default value is 7
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevMonthIconWidth

          public int getPrevMonthIconWidth()

      Width of the icon for the previous month button
      Returns:
        Current prevMonthIconWidth value. Default value is 7

    - #### setPrevYearIcon

          public DateChooser setPrevYearIcon(java.lang.String prevYearIcon)
                                      throws java.lang.IllegalStateException

      Icon for the previous year button
      Parameters:
        `prevYearIcon` - New prevYearIcon value. Default value is "[SKIN]doubleArrow_left.gif"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `com.smartgwt.client.widgets.DateChooser#setShowDoubleYearIcon`, `URL`

    - #### getPrevYearIcon

          public java.lang.String getPrevYearIcon()

      Icon for the previous year button
      Returns:
        Current prevYearIcon value. Default value is "[SKIN]doubleArrow_left.gif"
      See Also:
        `com.smartgwt.client.widgets.DateChooser#getShowDoubleYearIcon`, `URL`

    - #### setPrevYearIconHeight

          public DateChooser setPrevYearIconHeight(int prevYearIconHeight)
                                            throws java.lang.IllegalStateException

      Height of the icon for the previous year button
      Parameters:
        `prevYearIconHeight` - New prevYearIconHeight value. Default value is 7
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevYearIconHeight

          public int getPrevYearIconHeight()

      Height of the icon for the previous year button
      Returns:
        Current prevYearIconHeight value. Default value is 7

    - #### setPrevYearIconRTL

          public DateChooser setPrevYearIconRTL(java.lang.String prevYearIconRTL)

      Icon for the previous year button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextYearIcon` will be used in place of the `prevYearIcon` and vice versa.
      Parameters:
        `prevYearIconRTL` - New prevYearIconRTL value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `com.smartgwt.client.widgets.DateChooser#setShowDoubleYearIcon`, `URL`

    - #### getPrevYearIconRTL

          public java.lang.String getPrevYearIconRTL()

      Icon for the previous year button if `Page.isRTL()` is true. If not set, and the page is in RTL mode, the `nextYearIcon` will be used in place of the `prevYearIcon` and vice versa.
      Returns:
        Current prevYearIconRTL value. Default value is null
      See Also:
        `com.smartgwt.client.widgets.DateChooser#getShowDoubleYearIcon`, `URL`

    - #### setPrevYearIconWidth

          public DateChooser setPrevYearIconWidth(int prevYearIconWidth)
                                           throws java.lang.IllegalStateException

      Width of the icon for the previous year button
      Parameters:
        `prevYearIconWidth` - New prevYearIconWidth value. Default value is 14
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getPrevYearIconWidth

          public int getPrevYearIconWidth()

      Width of the icon for the previous year button
      Returns:
        Current prevYearIconWidth value. Default value is 14

    - #### setSelectedWeekStyle

          public DateChooser setSelectedWeekStyle(java.lang.String selectedWeekStyle)

      CSS style applied to the Fiscal Year and Week columns for the currently selected week (the one being displayed in the `week chooser`).
      Parameters:
        `selectedWeekStyle` - New selectedWeekStyle value. Default value is "dateChooserSelectedWeek"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getSelectedWeekStyle

          public java.lang.String getSelectedWeekStyle()

      CSS style applied to the Fiscal Year and Week columns for the currently selected week (the one being displayed in the `week chooser`).
      Returns:
        Current selectedWeekStyle value. Default value is "dateChooserSelectedWeek"
      See Also:
        `CSSStyleName`

    - #### setShowApplyButton

          public DateChooser setShowApplyButton(java.lang.Boolean showApplyButton)

      Determines whether the `applyButton` will be displayed.
      Parameters:
        `showApplyButton` - New showApplyButton value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getShowApplyButton

          public java.lang.Boolean getShowApplyButton()

      Determines whether the `applyButton` will be displayed.
      Returns:
        Current showApplyButton value. Default value is null

    - #### setShowCancelButton

          public DateChooser setShowCancelButton(java.lang.Boolean showCancelButton)

      Determines whether the "Cancel" button will be displayed.
      Parameters:
        `showCancelButton` - New showCancelButton value. Default value is false
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getShowCancelButton

          public java.lang.Boolean getShowCancelButton()

      Determines whether the "Cancel" button will be displayed.
      Returns:
        Current showCancelButton value. Default value is false

    - #### setShowFiscalYearChooser

          public DateChooser setShowFiscalYearChooser(java.lang.Boolean showFiscalYearChooser)

      When set to true, show a button that allows the calendar to be navigated by fiscal year.
      Parameters:
        `showFiscalYearChooser` - New showFiscalYearChooser value. Default value is false
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getShowFiscalYearChooser

          public java.lang.Boolean getShowFiscalYearChooser()

      When set to true, show a button that allows the calendar to be navigated by fiscal year.
      Returns:
        Current showFiscalYearChooser value. Default value is false

    - #### setShowSecondItem

          public DateChooser setShowSecondItem(java.lang.Boolean showSecondItem)

      When showing the `time field`, whether to show the "second" picker. When unset, the second field is not shown.
      Parameters:
        `showSecondItem` - New showSecondItem value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getShowSecondItem

          public java.lang.Boolean getShowSecondItem()

      When showing the `time field`, whether to show the "second" picker. When unset, the second field is not shown.
      Returns:
        Current showSecondItem value. Default value is null

    - #### setShowTimeItem

          public DateChooser setShowTimeItem(java.lang.Boolean showTimeItem)

      Whether to show the `time field` for editing the time portion of the date. When unset, the time field is shown automatically if the field type is "datetime". Note that the item's `second chooser` is not shown by default.
      Parameters:
        `showTimeItem` - New showTimeItem value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getShowTimeItem

          public java.lang.Boolean getShowTimeItem()

      Whether to show the `time field` for editing the time portion of the date. When unset, the time field is shown automatically if the field type is "datetime". Note that the item's `second chooser` is not shown by default.
      Returns:
        Current showTimeItem value. Default value is null

    - #### setShowTodayButton

          public DateChooser setShowTodayButton(java.lang.Boolean showTodayButton)

      Determines whether the "Today" button will be displayed, allowing the user to select the current date.
      Parameters:
        `showTodayButton` - New showTodayButton value. Default value is true
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getShowTodayButton

          public java.lang.Boolean getShowTodayButton()

      Determines whether the "Today" button will be displayed, allowing the user to select the current date.
      Returns:
        Current showTodayButton value. Default value is true

    - #### setShowWeekChooser

          public DateChooser setShowWeekChooser(java.lang.Boolean showWeekChooser)

      When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showFiscalYearChooser`.
      Parameters:
        `showWeekChooser` - New showWeekChooser value. Default value is false
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getShowWeekChooser

          public java.lang.Boolean getShowWeekChooser()

      When set to true, show a button that allows the calendar to be navigated by week or fiscal week, depending on the value of `showFiscalYearChooser`.
      Returns:
        Current showWeekChooser value. Default value is false

    - #### setShowWeekends

          public DateChooser setShowWeekends(java.lang.Boolean showWeekends)
                                      throws java.lang.IllegalStateException

      Whether weekend days should be shown. Which days are considered weekends is controlled by `weekendDays` if set or by `weekendDays` otherwise.
      Parameters:
        `showWeekends` - New showWeekends value. Default value is true
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowWeekends

          public java.lang.Boolean getShowWeekends()

      Whether weekend days should be shown. Which days are considered weekends is controlled by `weekendDays` if set or by `weekendDays` otherwise.
      Returns:
        Current showWeekends value. Default value is true

    - #### setSkinImgDir

          public DateChooser setSkinImgDir(java.lang.String skinImgDir)

      Overridden directory where images for this widget (such as the month and year button icons) may be found.

      Note : This is an advanced setting

      Overrides:
        `setSkinImgDir` in class `Canvas`
      Parameters:
        `skinImgDir` - New skinImgDir value. Default value is "images/common/"
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `SCImgURL`

    - #### getSkinImgDir

          public java.lang.String getSkinImgDir()

      Overridden directory where images for this widget (such as the month and year button icons) may be found.
      Overrides:
        `getSkinImgDir` in class `Canvas`
      Returns:
        Current skinImgDir value. Default value is "images/common/"
      See Also:
        `SCImgURL`

    - #### setStartYear

          public DateChooser setStartYear(int startYear)
                                   throws java.lang.IllegalStateException

      Earliest year that may be selected. If this chooser was opened by a `DateItem`, the default is inherited from `DateItem.startDate`. Otherwise, the default is 10 years before today.

      When opened from a `RelativeDateItem`, this property and `endYear` are defaulted to null, and the year-picker shows years surrounding the current year, according to `startYearRange` and `endYearRange`.

      Parameters:
        `startYear` - New startYear value. Default value is 2010
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getStartYear

          public int getStartYear()

      Earliest year that may be selected. If this chooser was opened by a `DateItem`, the default is inherited from `DateItem.startDate`. Otherwise, the default is 10 years before today.

      When opened from a `RelativeDateItem`, this property and `endYear` are defaulted to null, and the year-picker shows years surrounding the current year, according to `startYearRange` and `endYearRange`.

      Returns:
        Current startYear value. Default value is 2010

    - #### setStartYearRange

          public DateChooser setStartYearRange(java.lang.Integer startYearRange)
                                        throws java.lang.IllegalStateException

      When `startYear` is unset, this is the years before today that will be available for selection in the year menu.
      Parameters:
        `startYearRange` - New startYearRange value. Default value is 30
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getStartYearRange

          public java.lang.Integer getStartYearRange()

      When `startYear` is unset, this is the years before today that will be available for selection in the year menu.
      Returns:
        Current startYearRange value. Default value is 30

    - #### setStyleWeekends

          public DateChooser setStyleWeekends(java.lang.Boolean styleWeekends)
                                       throws java.lang.IllegalStateException

      Whether weekend days should be styled differently from weekdays. If false, suppresses the custom `baseWeekendStyle` and `weekendHeaderStyle`, instead using the `baseWeekdayStyle` and `weekendHeaderStyle`.
      Parameters:
        `styleWeekends` - New styleWeekends value. Default value is true
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getStyleWeekends

          public java.lang.Boolean getStyleWeekends()

      Whether weekend days should be styled differently from weekdays. If false, suppresses the custom `baseWeekendStyle` and `weekendHeaderStyle`, instead using the `baseWeekdayStyle` and `weekendHeaderStyle`.
      Returns:
        Current styleWeekends value. Default value is true

    - #### getTimeItem

          public TimeItem getTimeItem()
                               throws java.lang.IllegalStateException

      `TimeItem` for editing the time portion of dates. Visible by default for fields of type "datetime" and can be controlled by setting `showTimeItem`.

      This component is an AutoChild named "timeItem". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current timeItem value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setTimeItemProperties

          public DateChooser setTimeItemProperties(TimeItem timeItemProperties)
                                            throws java.lang.IllegalStateException

      Custom properties to apply to the `time field` used for editing the time portion of the date.

      Note : This is an advanced setting

      Parameters:
        `timeItemProperties` - New timeItemProperties value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getTimeItemProperties

          public TimeItem getTimeItemProperties()

      Custom properties to apply to the `time field` used for editing the time portion of the date.
      Returns:
        Current timeItemProperties value. Default value is null

    - #### setTimeItemTitle

          public DateChooser setTimeItemTitle(java.lang.String timeItemTitle)

      Title for the `time field`.
      Parameters:
        `timeItemTitle` - New timeItemTitle value. Default value is "Time"
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getTimeItemTitle

          public java.lang.String getTimeItemTitle()

      Title for the `time field`.
      Returns:
        Current timeItemTitle value. Default value is "Time"

    - #### getTodayButton

          public IButton getTodayButton()
                                 throws java.lang.IllegalStateException

      A button shown below the `calendar grid` which, when clicked, navigates the calendar to today.

      This component is an AutoChild named "todayButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current todayButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setTodayButtonHeight

          public DateChooser setTodayButtonHeight(java.lang.Integer todayButtonHeight)

      If set specifies a fixed height for the Today and Cancel buttons.
      Parameters:
        `todayButtonHeight` - New todayButtonHeight value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getTodayButtonHeight

          public java.lang.Integer getTodayButtonHeight()

      If set specifies a fixed height for the Today and Cancel buttons.
      Returns:
        Current todayButtonHeight value. Default value is null

    - #### setTodayButtonTitle

          public DateChooser setTodayButtonTitle(java.lang.String todayButtonTitle)

      Title for "Today" button.
      Parameters:
        `todayButtonTitle` - New todayButtonTitle value. Default value is "Today"
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getTodayButtonTitle

          public java.lang.String getTodayButtonTitle()

      Title for "Today" button.
      Returns:
        Current todayButtonTitle value. Default value is "Today"

    - #### setUse24HourTime

          public DateChooser setUse24HourTime(java.lang.Boolean use24HourTime)

      When showing the `time field`, whether the `TimeItem` should be set to use 24-hour time. The default is true.
      Parameters:
        `use24HourTime` - New use24HourTime value. Default value is true
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getUse24HourTime

          public java.lang.Boolean getUse24HourTime()

      When showing the `time field`, whether the `TimeItem` should be set to use 24-hour time. The default is true.
      Returns:
        Current use24HourTime value. Default value is true

    - #### setUseFirstDayOfFiscalWeek

          public DateChooser setUseFirstDayOfFiscalWeek(java.lang.Boolean useFirstDayOfFiscalWeek)

      When showing the `fiscal year chooser`, should firstDayOfWeek be defaulted to the same day as the fiscal start date? If true and a fiscal year starts on a Tuesday, the calendar will display Tuesday to Monday from left to right.
      Parameters:
        `useFirstDayOfFiscalWeek` - New useFirstDayOfFiscalWeek value. Default value is true
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getUseFirstDayOfFiscalWeek

          public java.lang.Boolean getUseFirstDayOfFiscalWeek()

      When showing the `fiscal year chooser`, should firstDayOfWeek be defaulted to the same day as the fiscal start date? If true and a fiscal year starts on a Tuesday, the calendar will display Tuesday to Monday from left to right.
      Returns:
        Current useFirstDayOfFiscalWeek value. Default value is true

    - #### getWeekChooserButton

          public IButton getWeekChooserButton()
                                       throws java.lang.IllegalStateException

      A button shown in the `navigation layout` which shows a picker for selecting a specific week of the year. When `showFiscalYearChooser` is true, the week number represents a fiscal week number, one offset from the start of the fiscal year. Otherwise, it represents a week number offset from the start of the calendar year.

      This component is an AutoChild named "weekChooserButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current weekChooserButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setWeekendDays

          public DateChooser setWeekendDays(int... weekendDays)

      An array of integer day-numbers that should be considered to be weekend days by this DateChooser instance. If unset, defaults to the set of days indicated `globally`.
      Parameters:
        `weekendDays` - New weekendDays value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `Visibility overview and related methods`

    - #### getWeekendDays

          public int[] getWeekendDays()

      An array of integer day-numbers that should be considered to be weekend days by this DateChooser instance. If unset, defaults to the set of days indicated `globally`.
      Returns:
        Current weekendDays value. Default value is null
      See Also:
        `Visibility overview and related methods`

    - #### setWeekendHeaderStyle

          public DateChooser setWeekendHeaderStyle(java.lang.String weekendHeaderStyle)

      Optional CSS style applied to the day-of-week headers for weekend days. If unset `headerStyle` will be applied to both weekdays and weekend days.
      Parameters:
        `weekendHeaderStyle` - New weekendHeaderStyle value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getWeekendHeaderStyle

          public java.lang.String getWeekendHeaderStyle()

      Optional CSS style applied to the day-of-week headers for weekend days. If unset `headerStyle` will be applied to both weekdays and weekend days.
      Returns:
        Current weekendHeaderStyle value. Default value is null

    - #### setWeekFieldTitle

          public DateChooser setWeekFieldTitle(java.lang.String weekFieldTitle)

      Title for the `week` field in the date grid.
      Parameters:
        `weekFieldTitle` - New weekFieldTitle value. Default value is "Wk"
      Returns:
        `DateChooser` instance, for chaining setter calls

    - #### getWeekFieldTitle

          public java.lang.String getWeekFieldTitle()

      Title for the `week` field in the date grid.
      Returns:
        Current weekFieldTitle value. Default value is "Wk"

    - #### setWeekHeaderStyle

          public DateChooser setWeekHeaderStyle(java.lang.String weekHeaderStyle)

      Base CSS style applied to the header of the `fiscal or calendar week column` in the `calendar view`.
      Parameters:
        `weekHeaderStyle` - New weekHeaderStyle value. Default value is null
      Returns:
        `DateChooser` instance, for chaining setter calls
      See Also:
        `CSSStyleName`

    - #### getWeekHeaderStyle

          public java.lang.String getWeekHeaderStyle()

      Base CSS style applied to the header of the `fiscal or calendar week column` in the `calendar view`.
      Returns:
        Current weekHeaderStyle value. Default value is null
      See Also:
        `CSSStyleName`

    - #### setWeekMenuStyle

          public DateChooser setWeekMenuStyle(java.lang.String weekMenuStyle)
                                       throws java.lang.IllegalStateException

      Style for the pop-up week menu.
      Parameters:
        `weekMenuStyle` - New weekMenuStyle value. Default value is "dateChooserWeekMenu"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `CSSStyleName`

    - #### getWeekMenuStyle

          public java.lang.String getWeekMenuStyle()

      Style for the pop-up week menu.
      Returns:
        Current weekMenuStyle value. Default value is "dateChooserWeekMenu"
      See Also:
        `CSSStyleName`

    - #### getYearChooserButton

          public IButton getYearChooserButton()
                                       throws java.lang.IllegalStateException

      A button shown in the `navigation layout` that shows a picker for selecting a specific calendar year.

      This component is an AutoChild named "yearChooserButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current yearChooserButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setYearMenuStyle

          public DateChooser setYearMenuStyle(java.lang.String yearMenuStyle)
                                       throws java.lang.IllegalStateException

      Style for the pop-up year menu.
      Parameters:
        `yearMenuStyle` - New yearMenuStyle value. Default value is "dateChooserYearMenu"
      Returns:
        `DateChooser` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `CSSStyleName`

    - #### getYearMenuStyle

          public java.lang.String getYearMenuStyle()

      Style for the pop-up year menu.
      Returns:
        Current yearMenuStyle value. Default value is "dateChooserYearMenu"
      See Also:
        `CSSStyleName`

    - #### cancelClick

          public void cancelClick()

      Fired when the user clicks the cancel button in this date chooser. Default implementation clears the date chooser.

    - #### addDataChangedHandler

          public com.google.gwt.event.shared.HandlerRegistration addDataChangedHandler(DataChangedHandler handler)

      Add a dataChanged handler.

      Add a notification to be fired whenever the data changes.

      Has no default behavior (so no need to call Super).

      Use `DateChooser.getData()` to get the current date value.

      Specified by:
        `addDataChangedHandler` in interface `HasDataChangedHandlers`
      Parameters:
        `handler` - the dataChanged handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### getData

          public java.util.Date getData()

      Get the current value of the picker.

      See `DateChooser.dataChanged()` for how to respond to the user picking a date.

      Returns:
        current date

    - #### getFiscalCalendar

          public FiscalCalendar getFiscalCalendar()

      Returns the `FiscalCalendar` object that will be used by this DateChooser.
      Returns:
        the fiscal calendar for this chooser, if set, or the global one otherwise

    - #### setData

          public void setData(java.util.Date date)

      Set the picker to show the given date.
      Parameters:
        `date` - new value

    - #### setFiscalCalendar

          public void setFiscalCalendar()

      Sets the `FiscalCalendar` object that will be used by this DateChooser. If unset, the `global fiscal calendar` is used.

    - #### setFiscalCalendar

          public void setFiscalCalendar(FiscalCalendar fiscalCalendar)

      Sets the `FiscalCalendar` object that will be used by this DateChooser. If unset, the `global fiscal calendar` is used.
      Parameters:
        `fiscalCalendar` - the fiscal calendar for this chooser

    - #### todayClick

          public void todayClick()

      Fired when the user clicks the Today button. Default implementation will select the current date in the date chooser.

    - #### setDefaultProperties

          public static void setDefaultProperties(DateChooser dateChooserProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `dateChooserProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setYearTitleFormatter

          public void setYearTitleFormatter(DateChooser.YearTitleFormatter formatter)

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.DateChooserLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `VLayout`